module MailDaemon
  module Helpers
    def setup_options(options)
      @options = options.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}
    end
    def reload_options(options)
      @options.merge!(options)
    end
    def default_option(name, value)
      @options[name.to_s.to_sym] = value unless @options.has_key?(name.to_s.to_sym)
    end
    def required_option(names)
      names_array = Array(names)
      names_array.each do |name|
        raise "#{name} is a required option, please supply this in the call to new" unless @options.has_key?(name.to_s.to_sym)
      end
    end
  end
end
