
module MailDaemon
  module Imap
    class Watcher

      def initialize(options)
        @options = options
      end

      def start(&block)

        @connection = Imap::Connection.new(@options, &block)
        @connection.login
        # @thread = Thread.new do
          @connection.wait_for_messages do |message|
            yield :type => "incoming_email", :mailbox => @options, :inbound_message => message
          end
        # end
        # @thread.join
      end

      def stop
        @connection.disconnect
        # @thread.terminate
      end

      def restart
        stop
        start
      end

      def running?
        @connection.running?
      end

      def mailbox
        @options[:mailbox]
      end

      def to_s
        "#{@options[:account_code]}/#{@options[:username]}"
      end

    end
  end
end
